/*
 * Check the definitions below this big long copyright message and make
 * sure they are right for your machine.  If your machine has a
 * <machine/endian.h>, then ignore this and use -DHAVE_MACHINE_ENDIAN_H
 * instead.
 *
 * This file taken from FreeBSD 2.1.0-Development, then lots of stuff
 * deleted.
 */
/*
 * Copyright (c) 1987, 1991 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	from: @(#)endian.h	7.8 (Berkeley) 4/3/91
 *	$Id: bsdendian.h,v 1.1.1.1 2000/05/08 22:51:24 wenqing Exp $
 */

#ifndef _MACHINE_ENDIAN_H_
#define _MACHINE_ENDIAN_H_ 1

/*
 * Definitions for byte order, according to byte significance from low
 * address to high.
 */
#define	LITTLE_ENDIAN	1234	/* LSB first: i386, vax */
#define	BIG_ENDIAN	4321	/* MSB first: 68000, ibm, net */
#define	PDP_ENDIAN	3412	/* LSB first in word, MSW first in long */

#if defined(__i386__) || defined(i386) || defined(__vax__) || defined(vax)
#define	BYTE_ORDER	LITTLE_ENDIAN
#endif

#if defined(__MIPSEL__) || defined(MIPSEL) || defined(__alpha)
#define BYTE_ORDER	LITTLE_ENDIAN
#endif

#ifndef BYTE_ORDER
#define BYTE_ORDER	BIG_ENDIAN
#endif

/*
 * Macros for network/external number representation conversion.
 */
#if BYTE_ORDER == BIG_ENDIAN && !defined(lint)
#ifndef __GNUC__
#define	ntohl(x)	(x)
#define	ntohs(x)	(x)
#define	htonl(x)	(x)
#define	htons(x)	(x)
#endif	

#define	NTOHL(x)	
#define	NTOHS(x)	
#define	HTONL(x)	
#define	HTONS(x)

#else

#if defined(__alpha)
extern unsigned int ntohl __P((unsigned int));
extern unsigned short ntohs __P((unsigned /*short*/ int));
extern unsigned int htonl __P((unsigned int));
extern unsigned short htons __P((unsigned /*short*/ int));

#define	NTOHL(x)	(void) ((x) = ntohl((u_int)x))
#define	NTOHS(x)	(void) ((x) = ntohs((u_short)x))
#define	HTONL(x)	(void) ((x) = htonl((u_int)x))
#define	HTONS(x)	(void) ((x) = htons((u_short)x))

#else	/* Default case: 32 bit ints and longs */

extern unsigned long ntohl __P((unsigned long));
extern unsigned short ntohs __P((unsigned /*short*/ int));
extern unsigned long htonl __P((unsigned long));
extern unsigned short htons __P((unsigned /*short*/ int));

#define	NTOHL(x)	(void) ((x) = ntohl((u_long)x))
#define	NTOHS(x)	(void) ((x) = ntohs((u_short)x))
#define	HTONL(x)	(void) ((x) = htonl((u_long)x))
#define	HTONS(x)	(void) ((x) = htons((u_short)x))
#endif	/* not 64-bit machine */

#endif /* not BIG_ENDIAN */
#endif /* _MACHINE_ENDIAN_H_ */
